var LOGFILE_NAME = "eragy-meter.log";
var l = new Logger(LOGFILE_NAME);

function addLeadingZeroes(number, count) {
	var result = '' + number;
	while (result.length < count) {
		result = '0' + result;
	}
	return result;
}

function createFullGETString(apikey, meterValueString) {
	var result = 'GET /energyremote.aspx?' + meterValueString + ' HTTP/1.1\r\n';
	result += 'X-Eragy-Apikey: ' + apikey + '\r\n';
	result += 'X-Eragy-Apiver: 1\r\n';

	result += 'Connection: close\r\n';
	result += 'User-Agent: dSS metering\r\n';
	result += 'Host: d.myeragy.com\r\n';
	result += 'Accept: text/html\r\n';
	result += '\r\n';

	return result;
}

function createMeterValueString(meterValue) {
	var content;
	content = 'data=';
	content += 'DSM1,' + Math.floor((new Date()).getTime() / 1000) + ','
			+ meterValue + ',1;';

	return content;
}

function sendMeterData() {
	
	var apikey = Property.getProperty("apiKey");
	if  ((apikey==null) || (apikey==""))
	{
		return;
	}
	
	var Meters=getNeededDSMs();
	var meterDSID=[];
	var minResolution=-1;
	var oSeries=Metering.getResolutions();
	for (var index in oSeries)
	{
		var object=oSeries[index];
		if (object.type=="energy") 
			if (minResolution==-1)
				minResolution=object.resolution;
			else 
				if (minResolution>object.resolution)
					minResolution=object.resolution;
		
	}
	if (minResolution==-1)
		l.logln("Konnte kleinste Auflösung nicht bestimmen");
	
	
	var aptValues;
	aptValues = 'data=';
	var iMeterCounter=0;
	var iValueCounter=0;
	for (var index in Meters)
	{
		var oMeter=Meters[index];
		var presentString="/apartment/dSMeters/" + oMeter.dsid +"/present"
		if (Property.getProperty(presentString)) 
		{
			var oValues=Metering.getValues(oMeter.dsid,"energy",minResolution);
			iMeterCounter++;
			for (var mIndex=0;(mIndex<oValues.length)&&(mIndex<5);mIndex++) {
				var sValue=oValues[mIndex];
				if (sValue!=null) {
					iValueCounter++;
					//l.logln("Wert: " + sValue.timestamp + " " + sValue.value);
					var year=parseInt(sValue.timestamp.substring(0,4),10);
					var mont=parseInt(sValue.timestamp.substring(5,7),10);
					mont-=1;
					var day=parseInt(sValue.timestamp.substring(8,10),10);
					var hour=parseInt(sValue.timestamp.substring(11,13),10);
					var minute=parseInt(sValue.timestamp.substring(14,16),10);
					var second=parseInt(sValue.timestamp.substring(17,19),10);
					
					var utz=new Date(year,mont,day,hour,minute,second,0);
					var utzVal=Math.floor(utz.getTime() / 1000); //(utz.getTimezoneOffset()*60)+
					
					aptValues += oMeter.dsid + ',' + utzVal + ','
					+ sValue.value + ',1;';
				}
			}
		}
	}
	var sString="ERAGY -> Sende " + iValueCounter + " Messwerte von " + iMeterCounter + " dSMs";
	
	var req = createFullGETString(apikey, aptValues);

	//l.logln(req);
	var socket = new TcpSocket();
	function onConnect(state, reqString) {
		if (state) {
			socket.send(reqString, function(bytesSent) {
				socket.receiveLine(128,
						function(data) {
							if (data != "HTTP/1.1 200 OK") {
								l.logln(sString + " NICHT ERFOLGREICH! Server Antwort: " + data);
							} else {
								l.logln(sString + " erfolgreich");
							}
							socket.close();
						});
			});
		} else {
			l.logln("Connection failed");
		}
	}

	socket.connect('d.myeragy.com', 80, function(state) {
		onConnect(state, req);
	});
}

function getNeededDSMs()
{
	var oReturnMeters=[]
	var Meters=getDSMeters();
	for (var index in Meters)
	{
		var oMeter=Meters[index];
		if (Property.getNode("dSM/" + oMeter.dsid + "/dSID")!=null)
		{
			if (Property.getProperty("dSM/" + oMeter.dsid + "/enabled")) {
				oReturnMeters.push(oMeter);
				//l.logln("Accept "+oMeter.dsid);
			}
		} else {
			oReturnMeters.push(oMeter);
			//l.logln("Not specified, so accept "+oMeter.dsid);
		}
	}
	return oReturnMeters;
}

function prepare()
{
	if (raisedEvent.parameter.apikey==null)
		return;
	var prop = new Property('apiKey');
	prop.setValue(raisedEvent.parameter.apikey);
	prop.setFlag('ARCHIVE', true);
	
	var Meters=getDSMeters();
	for (var index in Meters)
	{
		var oMeter=Meters[index];
		if (Property.getNode("dSM/" + oMeter.dsid + "/dSID")==null)
		{
			var prop = new Property("dSM/" + oMeter.dsid + "/dSID");
			prop.setValue(oMeter.dsid);
			prop.setFlag('ARCHIVE', true);
			prop = new Property("dSM/" + oMeter.dsid + "/enabled");
			prop.setValue(true);
			prop.setFlag('ARCHIVE', true);
		}
	}
	
	Property.store();
	sendMeterData();
}

function uploadCleanup()
{
  var id = Property.getProperty('id');
  var propNode = Property.getNode('/system/EventInterpreter/ScheduledEvents/' + id);
  if (propNode) {
    l.logln("eragy: cleanup old schedule " + id);
    propNode.getParent().removeChild(propNode);
  }
  Property.setProperty('id', 0);
}

function uploadScheduler()
{
	uploadCleanup();

	var ecount = Property.getProperty('count');
	Property.setProperty('count', ecount);

	var d = new Date();
	var diff = 60 - d.getSeconds() + 40;

	var uploadEvent = new TimedEvent("eragy", "+" + diff, { 'actions' : 'sendMeterData' });
	id = uploadEvent.raise();

	Property.setProperty('id', id);
	//l.logln("eragy: schedule id " + id + " in " + diff + "s");
}

function main() {
	if (raisedEvent.name === "running") {
		Property.load();
	}

	else if (raisedEvent.name === "eragy") {
		if (raisedEvent.parameter.actions) {

			l.logln('Execute: ' + raisedEvent.name + ' ' + raisedEvent.parameter.actions);

			if (raisedEvent.parameter.actions == 'load') {
				Property.load();
			}

			if (raisedEvent.parameter.actions == 'save') {
				Property.store();
			}

			if (raisedEvent.parameter.actions == 'prepare') {
				prepare();
			}

			if (raisedEvent.parameter.actions == 'ready') {
				var prop = new Property('count');
				prop.setValue(0);
				uploadScheduler();
			}

			if (raisedEvent.parameter.actions == 'sendMeterData') {
				sendMeterData();
				uploadScheduler();
			}

		}
	}
}

main();
